var search_data = {"index":{"searchIndex":["mustermann","stringscanner","scanresult","<<()","[]()","__getobj__()","beginning_of_line?()","cache_size()","check()","check_until()","check_until_with_prefix()","clear_cache()","create_pattern()","eos?()","getch()","inspect()","new()","new()","peek()","reset()","rest()","rest_size()","scan()","scan_until()","size()","terminate()","to_h()","to_s()","track_result()","unscan()"],"longSearchIndex":["mustermann","mustermann::stringscanner","mustermann::stringscanner::scanresult","mustermann::stringscanner#<<()","mustermann::stringscanner#[]()","mustermann::stringscanner::scanresult#__getobj__()","mustermann::stringscanner#beginning_of_line?()","mustermann::stringscanner::cache_size()","mustermann::stringscanner#check()","mustermann::stringscanner#check_until()","mustermann::stringscanner#check_until_with_prefix()","mustermann::stringscanner::clear_cache()","mustermann::stringscanner#create_pattern()","mustermann::stringscanner#eos?()","mustermann::stringscanner#getch()","mustermann::stringscanner#inspect()","mustermann::stringscanner::new()","mustermann::stringscanner::scanresult::new()","mustermann::stringscanner#peek()","mustermann::stringscanner#reset()","mustermann::stringscanner#rest()","mustermann::stringscanner#rest_size()","mustermann::stringscanner#scan()","mustermann::stringscanner#scan_until()","mustermann::stringscanner#size()","mustermann::stringscanner#terminate()","mustermann::stringscanner#to_h()","mustermann::stringscanner#to_s()","mustermann::stringscanner#track_result()","mustermann::stringscanner#unscan()"],"info":[["Mustermann","","Mustermann.html","",""],["Mustermann::StringScanner","","Mustermann/StringScanner.html","","<p>Class inspired by Ruby&#39;s StringScanner to scan an input string using multiple patterns.\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">require</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["Mustermann::StringScanner::ScanResult","","Mustermann/StringScanner/ScanResult.html","","<p>Encapsulates return values for {StringScanner#scan}, {StringScanner#check}, and friends. Behaves like …\n"],["<<","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-3C-3C","(string)","<p>Appends the given string to the string being scanned\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">require</span> <span class=\"ruby-string\">&#39;mustermann/string_scanner&#39;</span>\n<span class=\"ruby-identifier\">scanner</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["[]","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-5B-5D","(key)","<p>Shorthand for accessing {#params}. Accepts symbols as keys.\n"],["__getobj__","Mustermann::StringScanner::ScanResult","Mustermann/StringScanner/ScanResult.html#method-i-__getobj__","()","<p>@api private @!visibility private\n"],["beginning_of_line?","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-beginning_of_line-3F","()","<p>@return [true, false] whether or not the current position is at the start of a line\n"],["cache_size","Mustermann::StringScanner","Mustermann/StringScanner.html#method-c-cache_size","()","<p>@return [Integer] number of cached patterns @see clear_cache @api private\n"],["check","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-check","(pattern, **options)","<p>Checks if the given pattern matches any substring starting at the current position.\n<p>Does not affect {#position} …\n"],["check_until","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-check_until","(pattern, **options)","<p>Checks if the given pattern matches any substring starting at any position after the current position. …\n"],["check_until_with_prefix","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-check_until_with_prefix","(pattern, **options)",""],["clear_cache","Mustermann::StringScanner","Mustermann/StringScanner.html#method-c-clear_cache","()","<p>Patterns created by {#scan} will be globally cached, since we assume that there is a finite number of …\n"],["create_pattern","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-create_pattern","(pattern, **options)","<p>@!visibility private\n"],["eos?","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-eos-3F","()","<p>@return [true, false] whether or not the end of the string has been reached\n"],["getch","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-getch","()","<p>Reads a single character and advances the {#position} by one. @return [Mustermann::StringScanner::ScanResult, …\n"],["inspect","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-inspect","()","<p>@!visibility private\n"],["new","Mustermann::StringScanner","Mustermann/StringScanner.html#method-c-new","(string = \"\", **pattern_options)","<p>@example with different default type\n\n<pre>require &#39;mustermann/string_scanner&#39;\nscanner = Mustermann::StringScanner.new(&quot;foo/bar/baz&quot;, ...</pre>\n"],["new","Mustermann::StringScanner::ScanResult","Mustermann/StringScanner/ScanResult.html#method-c-new","(scanner, position, length, params = {})","<p>@api private\n"],["peek","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-peek","(length = 1)","<p>Allows to peek at a number of still unscanned characters without advacing the {#position}.\n<p>@param [Integer] …\n"],["reset","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-reset","()","<p>Resets the {#position} to the start and clears all {#params}. @return [Mustermann::StringScanner] the …\n"],["rest","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-rest","()","<p>@return [String] outstanding string not yet matched, empty string at end of input string\n"],["rest_size","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-rest_size","()","<p>@return [Integer] number of character remaining to be scanned\n"],["scan","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-scan","(pattern, **options)","<p>Checks if the given pattern matches any substring starting at the current position.\n<p>If it does, it will …\n"],["scan_until","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-scan_until","(pattern, **options)","<p>Checks if the given pattern matches any substring starting at any position after the current position. …\n"],["size","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-size","()","<p>@return [Integer] size of the input string\n"],["terminate","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-terminate","()","<p>Moves the position to the end of the input string. @return [Mustermann::StringScanner] the scanner itself …\n"],["to_h","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-to_h","()","<p>(see #params)\n"],["to_s","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-to_s","()","<p>@return [String] the input string @see #initialize @see #<<\n"],["track_result","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-track_result","(*results)","<p>@!visibility private\n"],["unscan","Mustermann::StringScanner","Mustermann/StringScanner.html#method-i-unscan","()","<p>Reverts the last operation that advanced the position.\n<p>Operations advancing the position: {#terminate}, …\n"]]}}